package com.zzsmart.qomo.kn.cost.manage.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zzsmart.qomo.kn.cost.manage.entity.HourRate;
import com.zzsmart.qomo.kn.cost.manage.service.IHourRateService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Arrays;

 /**
 * @Description: hour_rate
 * @Author: jeecg-boot
 * @Date:   2024-06-06
 * @Version: V1.0
 */
@Api(tags="小时费率")
@RestController
@RequestMapping("//hourRate")
@Slf4j
public class HourRateController extends JeecgController<HourRate, IHourRateService> {
	@Autowired
	private IHourRateService hourRateService;
	
	/**
	 * 分页列表查询
	 *
	 * @param hourRate
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "hour_rate-分页列表查询")
	@ApiOperation(value="hour_rate-分页列表查询", notes="hour_rate-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<HourRate>> queryPageList(HourRate hourRate,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<HourRate> queryWrapper = QueryGenerator.initQueryWrapper(hourRate, req.getParameterMap());
		Page<HourRate> page = new Page<HourRate>(pageNo, pageSize);
		IPage<HourRate> pageList = hourRateService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param hourRate
	 * @return
	 */
	@AutoLog(value = "hour_rate-添加")
	@ApiOperation(value="hour_rate-添加", notes="hour_rate-添加")
//	@RequiresPermissions(":hour_rate:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody HourRate hourRate) {
		hourRateService.save(hourRate);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param hourRate
	 * @return
	 */
	@AutoLog(value = "hour_rate-编辑")
	@ApiOperation(value="hour_rate-编辑", notes="hour_rate-编辑")
//	@RequiresPermissions(":hour_rate:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody HourRate hourRate) {
		hourRateService.updateById(hourRate);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "hour_rate-通过id删除")
	@ApiOperation(value="hour_rate-通过id删除", notes="hour_rate-通过id删除")
//	@RequiresPermissions(":hour_rate:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		hourRateService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "hour_rate-批量删除")
	@ApiOperation(value="hour_rate-批量删除", notes="hour_rate-批量删除")
//	@RequiresPermissions(":hour_rate:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.hourRateService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "hour_rate-通过id查询")
	@ApiOperation(value="hour_rate-通过id查询", notes="hour_rate-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<HourRate> queryById(@RequestParam(name="id",required=true) String id) {
		HourRate hourRate = hourRateService.getById(id);
		if(hourRate==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(hourRate);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param hourRate
    */
    @RequiresPermissions(":hour_rate:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, HourRate hourRate) {
        return super.exportXls(request, hourRate, HourRate.class, "hour_rate");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions(":hour_rate:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, HourRate.class);
    }

}
